Draft PathArray: Difference between revisions

From FreeCAD Documentation
No edit summary
No edit summary
(37 intermediate revisions by 6 users not shown)
Line 1: Line 1:
<languages/>
<translate>
<translate>
<!--T:35-->
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}

<!--T:1-->
<!--T:1-->
{{GuiCommand
{{GuiCommand|Name=Draft PathArray|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft → PathArray|SeeAlso=[[Draft Array|Draft Array]] }}
|Name=Draft PathArray
|MenuLocation=Draft → PathArray
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|SeeAlso=[[Draft PathLinkArray|Draft PathLinkArray]], [[Draft Array|Draft Array]], [[Draft LinkArray|Draft LinkArray]], [[Draft PointArray|Draft PointArray]]
|Version=0.14
}}


==Description== <!--T:2-->
==Description== <!--T:2-->


<!--T:3-->
<!--T:3-->
The PathArray tool places copies of a selected shape along a selected path. The path can be a Wire or one or more Edges. The shapes can optionally be aligned with the tangent of the path. If required, a translation Vector can be specified to shift the shapes so the centroid is on the path. If no objects are selected, you will be invited to select them.
The {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft PathArray|Draft PathArray]]}} tool places copies of a selected shape along a selected path, which can be a [[Draft Wire|Draft Wire]], a [[Draft BSpline|Draft BSpline]], and similar edges.

<!--T:22-->
The PathArray tool can be used on 2D shapes created with the [[Draft Workbench]], but can also be used on many types of 3D objects such as those created with the [[Part Workbench|Part]], [[PartDesign Workbench|PartDesign]], or [[Arch Workbench|Arch Workbench]]es.

<!--T:23-->
To position copies in an orthogonal array use [[Draft Array|Draft Array]]; to position copies at specified points use [[Draft PointArray|Draft PointArray]]; to create copies or clones, and manually place them use [[Draft Move|Draft Move]], [[Draft Rotate|Draft Rotate]], and [[Draft Clone|Draft Clone]].


</translate>
</translate>
[[Image:Draft_PathArray_Example.png|400px]]
[[Image:Draft_PathArray_Example.png|400px]]
<translate>
<translate>
<!--T:24-->
{{Caption|Object arranged along a path}}


==How to use== <!--T:4-->
==Usage== <!--T:4-->


<!--T:5-->
<!--T:5-->
# Select a shape object you wish to distribute.
# Select an object that you wish to distribute.
# Select a path object along which the shapes will be distributed. -or-
# Select a path object or some edges along which the object will be distributed.
# Press the {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft PathArray|Draft PathArray]]}} button.
# Select some edges of a path object.
# The Array object is immediately created. You must change the properties of the array to change the number and direction of copies created.
# Press the {{KEY|[[Image:Draft_PathArray.png|16px]] [[Draft PathArray]]}} button.

<!--T:25-->
Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

<!--T:26-->
The base object should be centred around the origin, even if the path starts somewhere else.


==Options== <!--T:6-->
==Options== <!--T:6-->


<!--T:7-->
<!--T:7-->
There are no options for this tool. Either it works with the selected objects or not.
* The array starts with shape copies which are not aligned to the path, nor translated to a new position by default. You can then change the count, alignment and/or translation vector in the properties.


==Properties== <!--T:8-->
==Properties== <!--T:8-->


<!--T:9-->
<!--T:9-->
* {{PropertyData|Base}}: The shape object
* {{PropertyData|Base}}: specifies the object to duplicate in the path.
* {{PropertyData|PathObj}}: The path object
* {{PropertyData|PathObj}}: specifies the path object.
* {{PropertyData|PathSubs}}: The subelements(edges) of path object to be used as the path
* {{PropertyData|PathSubs}}: specifies the sub-elements (edges) of the path object. This property does not yet appear in the [[property editor|property editor]].
* {{PropertyData|Count}}: The number of time to copy the shape
* {{PropertyData|Count}}: specifies the number of copies of the base object.
* {{PropertyData|Align}}: if it is {{TRUE}} the copies are aligned to the path; otherwise they are left in their default orientation.
* {{PropertyData|Xlate}}: The translation vector
:{{Emphasis|Note:}} in certain cases the shape will appear flat, in reality it may have moved in the 3D space, so instead of using a flat view, change the view to axonometric.
* {{PropertyData|Align}}: True to align the shapes to the path, False to leave shapes in their default orientation.
* {{PropertyData|Xlate}}: specifies a translation vector (x, y, z) to displace each copy along the path.
:{{Emphasis|Note:}} when {{PropertyData|Align}} is {{TRUE}}, the vector is relative to the local tangent, normal or binormal coordinates; otherwise the vector is relative to the global coordinates.


==Scripting== <!--T:10-->
==Scripting== <!--T:10-->
{{Emphasis|See also:}} [[Draft API|Draft API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:11-->
<!--T:11-->
The PathArray tool can by used in [[macros]] and from the python console by using the following function:
The PathArray tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:

</translate>
</translate>
{{Code|code=
{{Code|code=
makePathArray(shapeobject,pathobject,count,[translationvector],[alignment],[listofpathsubelements])
PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
}}
}}
<translate>
<translate>

<!--T:12-->
<!--T:12-->
* Creates a {{incode|PathArray}} object from the {{incode|baseobject}}, by placing as many as {{incode|count}} copies along {{incode|pathobject}}.
* Distribute count copies of a document shapeobject along a pathobject or subobjects of a pathobject. Optionally translates each copy by FreeCAD.Vector xlate direction and distance to adjust for difference in shape centre vs shape reference point. Optionally aligns baseobject to tangent/normal/binormal of path.
** If {{incode|pathobjsubs}} is given, it is a list of sub-objects of {{incode|pathobject}}, and the copies are created along this shorter path.
* If {{incode|xlate}} is given, it is a {{incode|FreeCAD.Vector}} that indicates an additional displacement to move the base point of the copies.
* If {{incode|align}} is {{incode|True}} the copies are aligned to the tangent, normal or binormal of the {{incode|pathobject}} at the point where the copy is placed.


<!--T:13-->
<!--T:13-->
Line 53: Line 83:
{{Code|code=
{{Code|code=
import FreeCAD,Draft
import FreeCAD,Draft

Draft.makePathArray(base,path,items,centretrans,orient,pathsubs)
p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)
}}
}}
<translate>
<translate>


==Usage Notes== <!--T:15-->
==Technical explanation for the Align property== <!--T:16-->
When {{PropertyData|Align}} is {{FALSE}}, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.
* Align + Xlate: When Align is True, the Xlate vector is relative to the local (tangent/normal/binormal) coordinates. When Align is False, the Xlate vector is relative to the global (XYZ) coordinates.
</translate>

==Limitations== <!--T:14-->
* This tool is not available before version 0.14
* The PathSubs Property does not yet appear in the properties list.

==Technical Explanation== <!--T:16-->
When "Align = false", PathArray's logic is quite easy to understand.
[[Image:patharray_NoAlign.png|600px|left|Align false]]
[[Image:patharray_NoAlign.png|600px|left|Align false]]
{{clear}}
{{clear}}
<translate>
<!--T:27-->
{{Caption|Object arranged along a closed path in the original orientation}}


<!--T:17-->
<!--T:17-->
When "Align = true" the logic is a bit harder to grasp:
When {{PropertyData|Align}} is {{TRUE}}, the positioning of the shapes becomes a bit more complex:
# Construct Frenet coordinate systems on the path (X is tangent, Z is normal, Y is binormal).
# First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
# Copy the original object to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.
# Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.
</translate>
[[Image:patharray alignment annotated.png|600px|left]]
{{clear}}
<translate>
<!--T:28-->
{{Caption|Object arranged along a closed path; description of components and path}}


<!--T:18-->
<!--T:18-->
The following images show how the array is produced, depending on which plane the path is.
It is much easier to understand with pictures:


<!--T:19-->
<!--T:19-->
Path on XY Plane:
[[Image:patharray_alignment.png|600px|left|XY Plane]]
</translate>
[[Image:patharray_alignment.png|600px|left]]
{{clear}}
{{clear}}
<translate>
XY Plane
<!--T:29-->
<br />
{{Caption|Object arranged along a closed path which is aligned to the XY plane}}
[[Image:patharray_alignment-XZ.png|600px|left|XZ Plane]]

<!--T:30-->
Path on XZ Plane:
</translate>
[[Image:patharray_alignment-XZ.png|600px|left]]
{{clear}}
{{clear}}
<translate>
XZ Plane
<!--T:31-->
<br />
{{Caption|Object arranged along a closed path which is aligned to the XZ plane}}
[[Image:patharray_alignment-YZ.png|600px|left|YZ Plane]]

<!--T:32-->
Path on YZ Plane:
</translate>
[[Image:patharray_alignment-YZ.png|600px|left]]
{{clear}}
{{clear}}
<translate>
YZ Plane
<!--T:33-->
<br />
{{Caption|Object arranged along a closed path which is aligned to the YZ plane}}
{{clear}}


<!--T:20-->
<!--T:20-->
The clear advantage of this logic is that as you reorient the path but not the object, the result is consistent - object remains aligned to the path the way it was before reorienting the path.
As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.


<!--T:21-->
<!--T:21-->
(Thanks to @DeepSOIC for this explanation)
{{Emphasis|Editor:}} thank you to user DeepSOIC for this explanation.
</translate>


<!--T:34-->
<languages/>
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}

</translate>
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}

Revision as of 20:36, 21 February 2020

Draft PathArray

Menu location
Draft → PathArray
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.14
See also
Draft PathLinkArray, Draft Array, Draft LinkArray, Draft PointArray

Description

The Draft PathArray tool places copies of a selected shape along a selected path, which can be a Draft Wire, a Draft BSpline, and similar edges.

The PathArray tool can be used on 2D shapes created with the Draft Workbench, but can also be used on many types of 3D objects such as those created with the Part, PartDesign, or Arch Workbenches.

To position copies in an orthogonal array use Draft Array; to position copies at specified points use Draft PointArray; to create copies or clones, and manually place them use Draft Move, Draft Rotate, and Draft Clone.

Object arranged along a path

Usage

  1. Select an object that you wish to distribute.
  2. Select a path object or some edges along which the object will be distributed.
  3. Press the Draft PathArray button.
  4. The Array object is immediately created. You must change the properties of the array to change the number and direction of copies created.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

The base object should be centred around the origin, even if the path starts somewhere else.

Options

There are no options for this tool. Either it works with the selected objects or not.

Properties

  • DataBase: specifies the object to duplicate in the path.
  • DataPathObj: specifies the path object.
  • DataPathSubs: specifies the sub-elements (edges) of the path object. This property does not yet appear in the property editor.
  • DataCount: specifies the number of copies of the base object.
  • DataAlign: if it is true the copies are aligned to the path; otherwise they are left in their default orientation.
Note: in certain cases the shape will appear flat, in reality it may have moved in the 3D space, so instead of using a flat view, change the view to axonometric.
  • DataXlate: specifies a translation vector (x, y, z) to displace each copy along the path.
Note: when DataAlign is true, the vector is relative to the local tangent, normal or binormal coordinates; otherwise the vector is relative to the global coordinates.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The PathArray tool can be used in macros and from the Python console by using the following function:

PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
  • Creates a PathArray object from the baseobject, by placing as many as count copies along pathobject.
    • If pathobjsubs is given, it is a list of sub-objects of pathobject, and the copies are created along this shorter path.
  • If xlate is given, it is a FreeCAD.Vector that indicates an additional displacement to move the base point of the copies.
  • If align is True the copies are aligned to the tangent, normal or binormal of the pathobject at the point where the copy is placed.

Example:

import FreeCAD,Draft

p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)

Technical explanation for the Align property

When DataAlign is false, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.

Align false
Align false

Object arranged along a closed path in the original orientation

When DataAlign is true, the positioning of the shapes becomes a bit more complex:

  1. First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
  2. Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.

Object arranged along a closed path; description of components and path

The following images show how the array is produced, depending on which plane the path is.

Path on XY Plane:

Object arranged along a closed path which is aligned to the XY plane

Path on XZ Plane:

Object arranged along a closed path which is aligned to the XZ plane

Path on YZ Plane:

Object arranged along a closed path which is aligned to the YZ plane

As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.

Editor: thank you to user DeepSOIC for this explanation.